//
// Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86_32.hpp"
#include "opto/cfgnode.hpp"
#include "opto/matcher.hpp"
#include "opto/opcodes.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 8;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 1;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NCXREGI, ncxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NADXREGI, nadxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NAXREGI, naxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RREGI, rRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, eAXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, eBXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, eCXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, eDXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, eDIRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, eSIRegI_rule, c)
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, load_long_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, load_long_indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EBPREGP, eBPRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(PREGP, pRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NABXREGP, nabxRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NAXREGP, naxRegP_rule, c)
    }
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, eRegP_no_EBP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, indirect_win95_safe_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGP, eRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, anyRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, eAXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGP, eBXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, eCXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, eSIRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGP, eDIRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    if(         
#line 3970 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 
#line 146 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGF, regF_rule, c)
    }
    if(         
#line 3951 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE < 2 
#line 154 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGFPR, regFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, regFPR1_rule, c)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    if(         
#line 3979 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 
#line 165 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGD, regD_rule, c)
    }
    if(         
#line 3916 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE < 2 
#line 173 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGDPR, regDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, regDPR1_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, regDPR2_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, regnotDPR1_rule, c)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EADXREGL_LOW_ONLY, eADXRegL_low_only_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGL, eRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, eADXRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, eBCXRegL_rule, c)
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, flagsReg_long_LEGT_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, flagsReg_long_EQNE_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, flagsReg_long_LTGE_rule, c)
    }
    if(         
#line 3888 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
false
#line 211 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, eFlagsRegUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, eFlagsRegU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, eFlagsReg_rule, c)
    }
}
void  State::_sub_Op_VecS(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECS, vecS_rule, c)
    }
}
void  State::_sub_Op_VecD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECD, vecD_rule, c)
    }
}
void  State::_sub_Op_VecX(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECX, vecX_rule, c)
    }
}
void  State::_sub_Op_VecY(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECY, vecY_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 1606 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 254 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 1594 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 263 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9445 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 274 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, absDPR_reg_rule, c)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 1581 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 288 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 1570 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 297 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) &&
        (
#line 10246 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 308 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR1, absFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, absFPR_reg_rule, c)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1132 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 320 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1120 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 329 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1120 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 340 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1108 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 351 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1097 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 362 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 373 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 384 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 395 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _MULD_REGDPR_REGDPR) &&
        (
#line 9651 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 406 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_MULD_REGDPR_REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_mulDPR_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGDPR_REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9651 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 418 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGDPR_REGDPR]+_kids[1]->_cost[REGDPR]+250;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_mulDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR_IMMDPR, _AddD_regDPR_immDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) &&
        (
#line 9537 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && _kids[1]->_leaf->getd() != 0.0 && _kids[1]->_leaf->getd() != 1.0 
#line 442 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR1) &&
        (
#line 9524 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 462 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR1]+125;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_imm1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR__LOADD_MEMORY_, _AddD_regDPR__LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD__LOADD_MEMORY__REGDPR, _AddD__LoadD_memory__regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9494 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 490 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9494 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 510 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR_REGDPR, _AddD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9465 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 534 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1061 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 557 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1049 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 566 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1049 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 577 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1037 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 588 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1026 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 599 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 610 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 621 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1002 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 632 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF_REGFPR_REGFPR) &&
        (
#line 10518 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 643 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF_REGFPR_REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGFPR_REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10518 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 653 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGFPR_REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF_REGFPR__LOADF_MEMORY_) &&
        (
#line 10496 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 667 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF_REGFPR__LOADF_MEMORY_]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGFPR__LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10496 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 681 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGFPR__LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF__LOADF_MEMORY__REGFPR) &&
        (
#line 10496 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 695 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF__LOADF_MEMORY__REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF__LOADF_MEMORY__REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10496 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 709 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF__LOADF_MEMORY__REGFPR]+_kids[1]->_cost[REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10355 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 723 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 737 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_imm_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10325 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 752 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 769 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_cisc_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 786 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_cisc_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10297 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 803 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10284 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 820 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10284 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 834 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10268 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 848 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10268 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 865 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10234 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 882 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10221 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 896 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+400;
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[0]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI_IMMI_M1, _AddI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI_M1, _AddI__LoadI_memory__immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI1, _AddI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI, _AddI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI__LOADI_MEMORY_, _AddI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__RREGI, _AddI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) &&
        (
#line 7040 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseIncDec
#line 1153 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, decI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) &&
        (
#line 7008 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseIncDec
#line 1197 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, incI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML_M1, _AddL__LoadL_memory__immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL_EREGL_IMML_M1, _AddL_eRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, subP_eReg_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, addP_eReg_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI]+110;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP_eReg_immI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET_WIN95_SAFE, indIndexScaleOffset_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2, _AddP_eRegP_no_EBP__LShiftI_rRegI_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE_WIN95_SAFE, indIndexScale_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_NO_EBP_RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_NO_EBP_RREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET_WIN95_SAFE, indIndexOffset_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_NO_EBP_RREGI, _AddP_eRegP_no_EBP_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDOFFSET32_WIN95_SAFE, indOffset32_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(INDOFFSET8_WIN95_SAFE, indOffset8_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_REGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_REGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDOFFSET32, load_long_indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indOffset32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP__LSHIFTI_RREGI_IMMI2) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP__LSHIFTI_RREGI_IMMI2]+_kids[1]->_cost[IMMI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET, indIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxScaleOff_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP__LSHIFTI_RREGI_IMMI2, _AddP_eRegP__LShiftI_rRegI_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE, indIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxScale_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[RREGI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_RREGI]+_kids[1]->_cost[IMMI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET, indIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxOff_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_RREGI, _AddP_eRegP_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMP]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32X, indOffset32X_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32, indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP32_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8, indOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP8_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_MEMORY, _AndI_rRegI_memory_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI, _AndI_rRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, and_cmpLTMask_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, and_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__CMPLTMASK_RREGI_RREGI, _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__CMPLTMASK_RREGI_RREGI_RREGI, _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 8120 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 1992 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8120 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2036 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 8105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2080 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2124 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0__LOADI_MEMORY_) &&
        (
#line 8059 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2168 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0__LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8059 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2212 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) &&
        (
#line 8046 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2256 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8046 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2300 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0_RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 8032 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2344 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8032 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2388 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 8019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2432 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2476 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI, _AndI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__LOADI_MEMORY_, _AndI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__RREGI, _AndI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMU31];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMU31, _AndI__LoadI_memory__immU31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_65535, _AndI__LoadI_memory__immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_255, _AndI__LoadI_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2UB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI16];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI16, _AndI__LoadUS_memory__immI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI_255, _AndI__LoadUS_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUB_MEMORY__IMMI8, _AndI__LoadUB_memory__immI8_rule, c)
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_32BITS]+250;
        DFA_PRODUCTION__SET_VALID(EREGL, zerox_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, zerox_long_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, zerox_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_RREGI_]+_kids[1]->_cost[IMML_32BITS]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convI2L_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 8934 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2814 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 8934 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2834 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_EREGL_IMML_M1) &&
        (
#line 8907 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2854 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_ADDL_EREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8907 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2874 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_EREGL_IMML_M1]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0__LOADL_MEMORY_) &&
        (
#line 8823 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2894 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0__LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 8823 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2914 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0_EREGL) &&
        (
#line 8798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2934 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_SUBL_IMML0_EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0_EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2954 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0_EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORL_EREGL_IMML_M1) &&
        (
#line 8777 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2974 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_XORL_EREGL_IMML_M1]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 8777 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 2994 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_EREGL_IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _XORL_EREGL_IMML_M1) &&
        (
#line 8758 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 3014 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_XORL_EREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8758 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 3034 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_EREGL_IMML_M1]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[IMML_32BITS];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_NADXREGI__IMML_32BITS, _AndL__ConvI2L_nadxRegI__immL_32bits_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EAXREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EAXREGI_]+_kids[1]->_cost[IMML_32BITS];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_EAXREGI__IMML_32BITS, _AndL__ConvI2L_eAXRegI__immL_32bits_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, array_equals_rule, c)
    }
}
void  State::_sub_Op_AtanD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9848 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 3156 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, atanD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9838 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 3165 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, atanDPR_reg_rule, c)
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LEGT) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_COMMUTE]+_kids[1]->_cost[FLAGSREG_LONG_LEGT];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT, _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_EQNE) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_EQNE];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FLAGSREG_LONG_EQNE, _Binary_cmpOp_flagsReg_long_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_, _Binary_eRegL__LoadL_load_long_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LTGE) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_LTGE];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FLAGSREG_LONG_LTGE, _Binary_cmpOp_flagsReg_long_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NADXREGI) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[NADXREGI]+_kids[1]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_NADXREGI_EAXREGI, _Binary_nadxRegI_eAXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_EAXREGI, _Binary_eSIRegP_eAXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_IMMI, _Binary_eSIRegP_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[EDXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_EDXREGI, _Binary_eDIRegP_eDXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_ESIREGP, _Binary_eDIRegP_eSIRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EDXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_EDXREGI, _Binary_eSIRegP_eDXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_ECXREGI, _Binary_eDIRegP_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGI_ECXREGI, _Binary_eAXRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGP) && STATE__VALID_CHILD(_kids[1], ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[EAXREGP]+_kids[1]->_cost[ECXREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGP_ECXREGP, _Binary_eAXRegP_eCXRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EBCXREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_EADXREGL_EBCXREGL, _Binary_eADXRegL_eBCXRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGI_RREGI, _Binary_eAXRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EAXREGP]+_kids[1]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGP_EREGP, _Binary_eAXRegP_eRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGL_EREGL, _Binary_eRegL_eRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGFPR_REGFPR, _Binary_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGDPR_REGDPR, _Binary_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGFPR1_REGFPR, _Binary_regFPR1_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGDPR1_REGDPR, _Binary_regDPR1_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_FCMOV) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_FCMOV]+_kids[1]->_cost[EFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FCMOV_EFLAGSREGU, _Binary_cmpOp_fcmov_eFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGP_EREGP, _Binary_eRegP_eRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI__LOADI_MEMORY_, _Binary_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPUCF_EFLAGSREGUCF, _Binary_cmpOpUCF_eFlagsRegUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU_EFLAGSREGU, _Binary_cmpOpU_eFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI_RREGI, _Binary_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_EFLAGSREG, _Binary_cmpOp_eFlagsReg_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_COMMUTE, cmpOp_commute_rule, c)
    }
    if(         
#line 4424 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
n->as_Bool()->_test._test != BoolTest::overflow &&
            n->as_Bool()->_test._test != BoolTest::no_overflow
#line 3305 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_FCMOV, cmpOp_fcmov_rule, c)
    }
    if(         
#line 4405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 3314 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF2, cmpOpUCF2_rule, c)
    }
    if(         
#line 4384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 3325 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF, cmpOpUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    if(         (
#line 12730 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
((CallStaticJavaNode*)n)->is_method_handle_invoke()
#line 3427 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaHandle_rule, c)
    }
    if(         (
#line 12711 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
! ((CallStaticJavaNode*)n)->is_method_handle_invoke()
#line 3435 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = 300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
      }
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(RREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(EAXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, castX2P_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_EREGP_, _CastP2X_eRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+50;
        DFA_PRODUCTION__SET_VALID(RREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, castPP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, checkCastPP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ECXREGI) && STATE__VALID_CHILD(_kids[1], EDIREGP) &&
        (
#line 11474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseFastStosb
#line 3558 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ECXREGI]+_kids[1]->_cost[EDIREGP]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_fast_stosb_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ECXREGI) && STATE__VALID_CHILD(_kids[1], EDIREGP) &&
        (
#line 11461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseFastStosb
#line 3567 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ECXREGI]+_kids[1]->_cost[EDIREGP]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 12676 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3580 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 12666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3589 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 12543 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3601 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 12533 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3612 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 12415 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3632 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 12405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3643 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 6943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 3663 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 6926 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 3674 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 6881 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 3685 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 6837 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 3696 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, fcmovDPR_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FCMOV_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR1_REGDPR) &&
        (
#line 6815 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 3716 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FCMOV_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGDPR1_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, fcmovDPR_regU_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 12695 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3738 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 12685 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3747 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 12561 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3757 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 12552 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3768 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 12433 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3782 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 12424 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3793 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 6916 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 3807 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 6899 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 3818 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 6863 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 3829 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 6850 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 3840 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, fcmovFPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, fcmovFPR_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FCMOV_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR1_REGFPR) &&
        (
#line 6826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 3854 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FCMOV_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGFPR1_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, fcmovFPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, fcmovFPR_regU_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 12644 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 3870 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 12634 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 3890 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 12511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 3934 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 12501 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 3978 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 12383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4022 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 12373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4066 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 6732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4110 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_memUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 6722 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4154 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 6711 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4198 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4242 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6691 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4286 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4330 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6664 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!VM_Version::supports_cmov() 
#line 4374 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, jmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6647 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!VM_Version::supports_cmov() 
#line 4418 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, jmovI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 12623 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4464 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 12612 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4476 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 12490 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4496 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 12479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4516 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 12362 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4536 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 12351 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4556 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 6974 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4576 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 6963 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4596 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 6952 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4616 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 12655 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4638 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_LEGT_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 12522 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4665 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_EQNE_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 12394 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4730 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_LTGE_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 6778 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4795 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_regUCF_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 6768 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4860 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_regU_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+300;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_reg_nonP6_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 6742 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4985 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_reg_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9352 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5052 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpD_ccmemCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9335 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5061 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+145;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpD_ccmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9323 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5070 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpD_ccCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9306 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5081 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+145;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpD_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 5092 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+200;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpDPR_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE <=1
#line 5103 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpDPR_cc_P6CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9227 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE <=1
#line 5114 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpDPR_cc_P6_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5127 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+275;
        DFA_PRODUCTION__SET_VALID(XREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpD_regmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9364 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5147 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+255;
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9292 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 5191 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR0) &&
        (
#line 9278 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 5235 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR0]+280;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpDPR_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10144 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5281 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpF_ccmemCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10127 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5290 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+165;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpF_ccmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5299 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpF_ccCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10098 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5310 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+145;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpF_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10050 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0
#line 5321 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+200;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpFPR_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10036 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE == 0
#line 5332 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpFPR_cc_P6CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10018 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE == 0
#line 5343 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpFPR_cc_P6_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10176 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5356 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+275;
        DFA_PRODUCTION__SET_VALID(XREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpF_regmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10156 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5376 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+255;
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10084 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0
#line 5420 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR0) &&
        (
#line 10070 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0
#line 5464 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR0]+280;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpFPR_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_MEMORY]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, cmpL_reg_flags_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+300;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_LEGT) || _cost[FLAGSREG_LONG_LEGT] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, cmpL_zero_flags_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, cmpL_reg_flags_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+200;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_EQNE) || _cost[FLAGSREG_LONG_EQNE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, cmpL_zero_flags_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, cmpL_reg_flags_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_LTGE) || _cost[FLAGSREG_LONG_LTGE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, cmpL_zero_flags_LTGE_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+1000;
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CMPLTMASK_RREGI_RREGI, _CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpLTMask0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[NCXREGI]+400;
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpLTMask_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_ESIREGP_EAXREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_ESIREGP_EAXREGP]+_kids[1]->_cost[IMMP0]+1000;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, partialSubtypeCheck_vs_Zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMI0]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testP_Reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testP_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) &&
        (
#line 11747 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 n->in(2)->in(2)->bottom_type()->reloc() == relocInfo::none 
#line 5671 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_mem_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMP]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGP]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, testU_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) &&
        (
#line 7214 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cx8()
#line 5741 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGP_ECXREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapP_rule, c)
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xaddI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7252 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
n->as_LoadStore()->result_not_used()
#line 5795 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddI_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xchgI_rule, c)
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], PREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[PREGP]+100;
        DFA_PRODUCTION__SET_VALID(PREGP, xchgP_rule, c)
    }
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 3491 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && jlong_cast(n->getd()) == 0 
#line 5828 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, loadConD0_rule, c+100)
    }
    if(         
#line 3478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5837 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_rule, c+125)
      }
    }
    if(         
#line 3469 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 5848 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR, immDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR_rule, c+125)
    }
    if(         
#line 3459 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && n->getd() == 1.0 
#line 5860 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR1, immDPR1_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR1_rule, c+125)
      }
    }
    if(         
#line 3449 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && n->getd() == 0.0 && !g_isnan(n->getd()) 
#line 5880 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR0, immDPR0_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR0_rule, c+125)
      }
    }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 3540 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE >= 1 && jint_cast(n->getf()) == 0 
#line 5902 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, loadConF0_rule, c+100)
    }
    if(         
#line 3530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE >= 1
#line 5911 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_rule, c+125)
      }
    }
    if(         
#line 3520 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE == 0 
#line 5922 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR, immFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR_rule, c+125)
    }
    if(         
#line 3510 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0 && n->getf() == 1.0F
#line 5932 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR1, immFPR1_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR1_rule, c+125)
      }
    }
    if(         
#line 3500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0 && n->getf() == 0.0F
#line 5946 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR0, immFPR0_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR0_rule, c+125)
      }
    }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 3578 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == 65535
#line 5963 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 3569 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 255 
#line 5971 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 3560 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 24 
#line 5979 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 3552 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 16 
#line 5987 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 3358 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 3 
#line 5995 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_3, immI_3_rule, c)
    }
    if(         
#line 3349 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 2 
#line 6003 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_2, immI_2_rule, c)
    }
    if(         
#line 3340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 1 
#line 6011 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 3331 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ >= 32 && _n_get_int__ <= 63 
#line 6019 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32_63, immI_32_63_rule, c)
    }
    if(         
#line 3322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ >= 1 && _n_get_int__ <= 31 
#line 6027 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1_31, immI_1_31_rule, c)
    }
    if(         
#line 3313 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 32 
#line 6035 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 3303 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ >= 0
#line 6043 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMU31, immU31_rule, c)
    }
    if(         
#line 3292 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
(-32768 <= _n_get_int__) && (_n_get_int__ <= 32767)
#line 6051 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI16, immI16_rule, c)
    }
    if(         
#line 3283 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
(-128 <= _n_get_int__) && (_n_get_int__ <= 127)
#line 6059 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI8, immI8_rule, c)
    }
    if(         
#line 3275 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 6067 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI2, immI2_rule, c)
    }
    if(         
#line 3265 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == -1
#line 6075 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 3255 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == 1
#line 6083 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI1, immI1_rule, c)
    }
    if(         
#line 3245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == 0
#line 6091 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadConI0_rule, c+50)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadConI_rule, c+100)
      }
    }
   if ( /* RREGI KNOWN_VALID || */ _cost[RREGI] > 100) {
     DFA_PRODUCTION(RREGI, loadConI_rule, 100)
   }
   if ( /* STACKSLOTI KNOWN_VALID || */ _cost[STACKSLOTI] > 100+100) {
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 100+100)
   }
   if ( /* XREGI KNOWN_VALID || */ _cost[XREGI] > 100) {
     DFA_PRODUCTION(XREGI, loadConI_rule, 100)
   }
   if ( /* EAXREGI KNOWN_VALID || */ _cost[EAXREGI] > 100) {
     DFA_PRODUCTION(EAXREGI, loadConI_rule, 100)
   }
   if ( /* NCXREGI KNOWN_VALID || */ _cost[NCXREGI] > 100) {
     DFA_PRODUCTION(NCXREGI, loadConI_rule, 100)
   }
   if ( /* EBXREGI KNOWN_VALID || */ _cost[EBXREGI] > 100) {
     DFA_PRODUCTION(EBXREGI, loadConI_rule, 100)
   }
   if ( /* NADXREGI KNOWN_VALID || */ _cost[NADXREGI] > 100) {
     DFA_PRODUCTION(NADXREGI, loadConI_rule, 100)
   }
   if ( /* ECXREGI KNOWN_VALID || */ _cost[ECXREGI] > 100) {
     DFA_PRODUCTION(ECXREGI, loadConI_rule, 100)
   }
   if ( /* NAXREGI KNOWN_VALID || */ _cost[NAXREGI] > 100) {
     DFA_PRODUCTION(NAXREGI, loadConI_rule, 100)
   }
   if ( /* EDXREGI KNOWN_VALID || */ _cost[EDXREGI] > 100) {
     DFA_PRODUCTION(EDXREGI, loadConI_rule, 100)
   }
   if ( /* EDIREGI KNOWN_VALID || */ _cost[EDIREGI] > 100) {
     DFA_PRODUCTION(EDIREGI, loadConI_rule, 100)
   }
   if ( /* ESIREGI KNOWN_VALID || */ _cost[ESIREGI] > 100) {
     DFA_PRODUCTION(ESIREGI, loadConI_rule, 100)
   }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3437 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_long__ == (int)(_n_get_long__)
#line 6190 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML32, immL32_rule, c)
        DFA_PRODUCTION__SET_VALID(EADXREGL_LOW_ONLY, loadConL_low_only_rule, c+250)
    }
    if(         
#line 3427 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 6199 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 3417 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
(0 <= _n_get_long__) && (_n_get_long__ <= 127)
#line 6207 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_127, immL_127_rule, c)
    }
    if(         
#line 3406 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_long__ == -1L 
#line 6215 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 3396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_long__ == 0L 
#line 6223 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, loadConL0_rule, c+150)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+150+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadConL0_rule, c+150)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadConL0_rule, c+150)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadConL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadConL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadConL_rule, c+200)
      }
    }
   if ( /* EREGL KNOWN_VALID || */ _cost[EREGL] > 200) {
     DFA_PRODUCTION(EREGL, loadConL_rule, 200)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > 200+200) {
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 200+200)
   }
   if ( /* EADXREGL KNOWN_VALID || */ _cost[EADXREGL] > 200) {
     DFA_PRODUCTION(EADXREGL, loadConL_rule, 200)
   }
   if ( /* EBCXREGL KNOWN_VALID || */ _cost[EBCXREGL] > 200) {
     DFA_PRODUCTION(EBCXREGL, loadConL_rule, 200)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3377 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 n->get_ptr() == 0 
#line 6265 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadConP_rule, c+100+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(PREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(DIRECT, direct_rule, c)
        DFA_PRODUCTION(MEMORY, direct_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(LONG_MEMORY, direct_rule, c)	  // overwrites higher cost rule
    }
     DFA_PRODUCTION(EREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ANYREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EAXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EREGP_NO_EBP, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(INDIRECT_WIN95_SAFE, loadConP_rule, 100+100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EBXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NAXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(PREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ECXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NABXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ESIREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_REGP, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_INDIRECT, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_MEMORY, load_long_indirect_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EDIREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(INDIRECT, loadConP_rule, 100)	  // overwrites higher cost rule
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_IMMF__) &&
        (
#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=1
#line 6375 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_IMMF__]+150;
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D__LOADF_MEMORY___) &&
        (
#line 1682 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=1
#line 6384 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D__LOADF_MEMORY___]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_REGF__) &&
        (
#line 1670 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=1
#line 6395 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_REGF__]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10683 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6406 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10660 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==1
#line 6417 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convDPR2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10650 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 6428 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convDPR2FPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1];
        DFA_PRODUCTION__SET_VALID(_CONVD2F_REGDPR1_, _ConvD2F_regDPR1__rule, c)
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10760 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6445 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convD2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10740 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 6465 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convDPR2I_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10811 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6511 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10788 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 6523 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convDPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convDPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convDPR2L_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF) ) {
      unsigned int c = _kids[0]->_cost[IMMF];
        DFA_PRODUCTION__SET_VALID(_CONVF2D_IMMF_, _ConvF2D_immF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVF2D__LOADF_MEMORY__, _ConvF2D__LoadF_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_CONVF2D_REGF_, _ConvF2D_regF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10729 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6557 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==1
#line 6566 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convF2DPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==1
#line 6578 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, convFPR2D_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 6599 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convFPR2DPR_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10890 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 6621 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convF2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 6641 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convFPR2I_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10942 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 6687 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convF2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10918 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 6699 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convFPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convFPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convFPR2L_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && !Compile__current____select_24_bit_instr__
#line 6722 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convI2DPR_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11025 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && UseXmmI2D 
#line 6734 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convXI2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 
#line 6743 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && !UseXmmI2D 
#line 6754 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 10994 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 6765 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convI2DPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11123 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && UseXmmI2F 
#line 6788 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convXI2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11112 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==1 || UseSSE>=2 && !UseXmmI2F 
#line 6797 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11100 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 6808 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, convI2FPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, convI2FPR_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11088 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 6818 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, convI2FPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, convI2FPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11075 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 6832 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+200;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convI2FPR_SSF_mem_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11062 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 6847 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convI2FPR_SSF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11050 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && n->in(1)->Opcode() == Op_AndI && n->in(1)->in(2)->is_Con() && n->in(1)->in(2)->get_int() == 255 
#line 6864 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, conv24I2FPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, conv24I2FPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_RREGI_, _ConvI2L_rRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+375;
        DFA_PRODUCTION__SET_VALID(EREGL, convI2L_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, convI2L_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convI2L_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_EAXREGI_, _ConvI2L_eAXRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NADXREGI) ) {
      unsigned int c = _kids[0]->_cost[NADXREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_NADXREGI_, _ConvI2L_nadxRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMU31]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immU31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI16) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI16]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_immI16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_immI16_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_immI16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUB_MEMORY__IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUB_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUB2L_immI8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUB2L_immI8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUB2L_immI8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadB2L_rule, c)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11185 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7070 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11171 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7079 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, convL2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convL2FPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11200 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 7100 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convL2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63) &&
        (
#line 7420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7128 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63]+1*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_RShift_high_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63) &&
        (
#line 7420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7174 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63]+1*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_RShift_high_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32) &&
        (
#line 7405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7220 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32]+0*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_high_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32) &&
        (
#line 7405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7266 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32]+0*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_high_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_CONVL2I_EREGL_, _ConvL2I_eRegL__rule, c)
    }
}
void  State::_sub_Op_CosD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 9806 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7316 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+1800;
        DFA_PRODUCTION__SET_VALID(REGD, cosD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9796 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7325 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+1800;
        DFA_PRODUCTION__SET_VALID(REGDPR1, cosDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, cosDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, cosDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cosDPR_reg_rule, c)
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5031 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseCountLeadingZerosInstruction
#line 7357 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosI_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseCountLeadingZerosInstruction
#line 7377 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5079 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseCountLeadingZerosInstruction
#line 7423 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosL_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5056 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseCountLeadingZerosInstruction
#line 7443 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5127 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseCountTrailingZerosInstruction
#line 7489 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosI_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseCountTrailingZerosInstruction
#line 7509 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5170 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseCountTrailingZerosInstruction
#line 7555 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosL_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseCountTrailingZerosInstruction
#line 7575 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EAXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, CreateException_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1558 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 7645 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 7654 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1534 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 7665 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7676 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7687 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1499 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7698 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_DIVD_REGDPR_REGDPR, _DivD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGNOTDPR1) &&
        (
#line 9704 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && Compile::current()->has_method() && Compile::current()->method()->is_strict() 
#line 7713 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGNOTDPR1]+01;
        DFA_PRODUCTION__SET_VALID(REGDPR1, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, strictfp_divDPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 7725 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, divDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1487 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 7748 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1475 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 7757 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1463 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 7768 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1452 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7779 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1440 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7790 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1428 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7801 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 7812 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, divFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, divFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10550 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 7822 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, divFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBF_REGFPR_REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10534 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 7837 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBF_REGFPR_REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, subFPR_divFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, subFPR_divFPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, divI_eReg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML32]+1000;
        DFA_PRODUCTION__SET_VALID(EADXREGL, divL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, divL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, divL_eReg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+10000;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, divL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, divL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, divL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_DivModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModI_eReg_divmod_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EDIREGP_EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EDIREGP_EDXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, encode_iso_array_rule, c)
    }
}
void  State::_sub_Op_ExpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 9914 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7917 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, expD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9903 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7926 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, expDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, expDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, expDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, expDPR_reg_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EBXREGP) &&
        (
#line 12894 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!Compile::current()->use_rtm()
#line 7940 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EBXREGP]+300;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastLock_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EBXREGP) &&
        (
#line 12878 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
Compile::current()->use_rtm()
#line 7949 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EBXREGP]+300;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastLockRTM_rule, c)
      }
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EAXREGP]+300;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpDir_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LEGT) &&
        (
#line 12602 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le 
#line 7980 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_COMMUTE]+_kids[1]->_cost[FLAGSREG_LONG_LEGT]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_EQNE) &&
        (
#line 12470 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 7989 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_EQNE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LTGE) &&
        (
#line 12342 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 8000 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_LTGE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF2) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF2]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpCon_rule, c)
      }
    }
}
void  State::_sub_Op_Jump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+350;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_rule, c)
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI_32_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI, _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI0_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI, _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_M1, _LShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI_ECXREGI, _LShiftI_ncxRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI8, _LShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI1, _LShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], XREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[XREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_XREGI_IMMI_16, _LShiftI_xRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], XREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[XREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_XREGI_IMMI_24, _LShiftI_xRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, salI_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, salI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shlI_eReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADUS_MEMORY__IMMI_24, _LShiftI__LoadUS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI2, _LShiftI_rRegI_immI2_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+500+200;
        DFA_PRODUCTION__SET_VALID(EREGL, salL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, salL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, salL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_1_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_3) &&
        (
#line 9075 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseNewLongLShift
#line 8227 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_3]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_3_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_3_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_2) &&
        (
#line 9056 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseNewLongLShift
#line 8247 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_2]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 9041 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseNewLongLShift
#line 8267 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(XREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(XREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADD_MEMORY_, _LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5739 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && !UseXmmLoadAndClearUpper
#line 8356 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_partial_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5728 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && UseXmmLoadAndClearUpper
#line 8365 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, loadD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5714 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8376 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGDPR, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadDPR_rule, c)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADF_MEMORY_, _LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5764 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 8394 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGFPR, loadFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5752 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 8404 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGF, loadF_rule, c)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadKlass_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_MEMORY) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_LOAD_LONG_MEMORY_, _LoadL_load_long_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5661 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((LoadLNode*)n)->require_atomic_access()
#line 8464 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+160;
        DFA_PRODUCTION__SET_VALID(EREGL, loadLX_reg_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadLX_reg_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadLX_reg_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5647 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((LoadLNode*)n)->require_atomic_access()
#line 8476 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+180;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadLX_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5636 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && ((LoadLNode*)n)->require_atomic_access()
#line 8496 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadL_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_MEMORY) &&
        (
#line 5615 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!((LoadLNode*)n)->require_atomic_access()
#line 8516 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_MEMORY]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadPLocked_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADP_MEMORY_, _LoadP_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadS_rule, c)
    }
}
void  State::_sub_Op_LogD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 9984 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8632 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, logD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8641 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, logDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, logDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, logDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, logDPR_reg_rule, c)
    }
}
void  State::_sub_Op_Log10D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 9949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8655 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, log10D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9931 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8664 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, log10DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, log10DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, log10DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, log10DPR_reg_rule, c)
    }
}
void  State::_sub_Op_LoopLimit(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_NADXREGI_EAXREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_NADXREGI_EAXREGI]+_kids[1]->_cost[IMMI]+300;
        DFA_PRODUCTION__SET_VALID(EAXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loopLimit_eReg_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, maxI_eReg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_0_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_0_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 6608 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
Matcher::post_store_load_barrier(n)
#line 8747 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, minI_eReg_rule, c)
    }
}
void  State::_sub_Op_ModD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9750 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8787 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+250;
        DFA_PRODUCTION__SET_VALID(REGD, modD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9736 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8796 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, modDPR_reg_rule, c)
    }
}
void  State::_sub_Op_ModF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10603 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 8811 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+250;
        DFA_PRODUCTION__SET_VALID(REGF, modF_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10590 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8820 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, modFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, modFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10576 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8830 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, modFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+300;
        DFA_PRODUCTION__SET_VALID(EDXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, modI_eReg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML32]+1000;
        DFA_PRODUCTION__SET_VALID(EADXREGL, modL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, modL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, modL_eReg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+10000;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, modL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, modL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, modL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11324 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8888 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+85;
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 8897 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+95;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_stack_reg_sse_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11297 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 8908 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+125;
        DFA_PRODUCTION__SET_VALID(REGFPR, MoveI2FPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, MoveI2FPR_stack_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11272 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8930 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, MoveF2I_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11259 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 8950 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 8994 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+125;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveFPR2I_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11442 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 9079 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+85;
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11429 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && !UseXmmLoadAndClearUpper
#line 9088 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+95;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_sse_partial_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11416 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && UseXmmLoadAndClearUpper
#line 9099 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+95;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_sse_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11401 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 9110 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
        DFA_PRODUCTION__SET_VALID(REGDPR, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, MoveL2DPR_stack_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+200;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11372 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 9140 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION__SET_VALID(EREGL, MoveD2L_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, MoveD2L_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, MoveD2L_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11360 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 9152 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 11349 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 9172 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+125;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveDPR2L_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1416 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9209 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1404 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9218 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1404 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9229 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1392 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9240 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1381 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9251 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1369 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9262 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1369 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9273 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1357 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9284 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_MULD_REGDPR_REGDPR, _MulD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 9299 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR]+200;
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 9311 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) &&
        (
#line 9604 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[1]->_leaf->getd() != 0.0 && _kids[1]->_leaf->getd() != 1.0 
#line 9331 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGNOTDPR1) &&
        (
#line 9585 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && Compile::current()->has_method() && Compile::current()->method()->is_strict() 
#line 9351 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGNOTDPR1]+1;
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, strictfp_mulDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9565 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 9371 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1345 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9394 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9403 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9414 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1321 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9425 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1310 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9436 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1298 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9447 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1298 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9458 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1286 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9469 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_MULF_REGFPR_REGFPR, _MulF_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_MULF_REGFPR__LOADF_MEMORY_, _MulF_regFPR__LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_MULF__LOADF_MEMORY__REGFPR, _MulF__LoadF_memory__regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 9492 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10445 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 9502 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_imm_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10431 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 9517 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_mem_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10418 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 9534 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10418 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 9548 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10402 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 9562 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10402 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 9579 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10385 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 9596 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10370 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 9610 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+350;
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML_127) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML_127]+2*100+2*400;
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_con_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_con_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_con_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 7544 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
is_operand_hi32_zero(n->in(1)) && is_operand_hi32_zero(n->in(2))
#line 9809 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+1*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_hi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_hi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_hi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 7523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
is_operand_hi32_zero(n->in(2))
#line 9829 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+2*100+2*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_rhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_rhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_rhi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 7502 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
is_operand_hi32_zero(n->in(1))
#line 9849 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+2*100+2*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_lhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_lhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_lhi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+4*100+3*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_NADXREGI__IMML_32BITS) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_EAXREGI__IMML_32BITS) &&
        /*mask*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_NADXREGI__IMML_32BITS]+_kids[1]->_cost[_ANDL__CONVI2L_EAXREGI__IMML_32BITS]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulIS_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulIS_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulIS_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_EAXREGI__IMML_32BITS) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_NADXREGI__IMML_32BITS) &&
        /*mask*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_EAXREGI__IMML_32BITS]+_kids[1]->_cost[_ANDL__CONVI2L_NADXREGI__IMML_32BITS]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulIS_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulIS_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulIS_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_EAXREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[_CONVI2L_EAXREGI_]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulI2L_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EAXREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_NADXREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EAXREGI_]+_kids[1]->_cost[_CONVI2L_NADXREGI_]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], _CONVI2L_NADXREGI_) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL_LOW_ONLY]+_kids[1]->_cost[_CONVI2L_NADXREGI_];
        DFA_PRODUCTION__SET_VALID(_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_, _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], EADXREGL_LOW_ONLY) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[EADXREGL_LOW_ONLY];
        DFA_PRODUCTION__SET_VALID(_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY, _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule, c)
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 1656 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9956 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 1644 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9965 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9455 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 9976 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, negDPR_reg_rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9990 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 1620 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9999 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) &&
        (
#line 10256 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 10010 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR1, negFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, negFPR_reg_rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C32_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI1]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, rorI_eReg_i1_0_rule, c)
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_i1_0_rule, c)
      }
        DFA_PRODUCTION__SET_VALID(EBXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, rorI_eReg_i1_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rorI_eReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI8) &&
        (
#line 8248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
  0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 10134 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI8) &&
        (
#line 8248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
  0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 10178 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__IMMI, _OrI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORI_RREGI__LOADI_MEMORY_, _OrI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__RREGI, _OrI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_EREGP_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_EREGP_]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_castP2X_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CASTP2X_EREGP_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CASTP2X_EREGP_]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowAddI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowAddI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[EAXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowNegI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowSubI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowSubI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowMulI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowMulI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGP];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_ESIREGP_EAXREGP, _PartialSubtypeCheck_eSIRegP_eAXRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGP]+1100;
        DFA_PRODUCTION__SET_VALID(EDIREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, partialSubtypeCheck_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 5215 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 10674 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5203 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 10694 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 5245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 10740 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5228 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 10760 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PowD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 10806 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, powD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR1) &&
        (
#line 9869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10815 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, powDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, powDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, powDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, powDPR_reg_rule, c)
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6207 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==2
#line 10829 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6195 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==1
#line 10838 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6183 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==0
#line 10849 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6171 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
AllocatePrefetchInstr==3
#line 10860 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6161 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && AllocatePrefetchInstr!=3
#line 10871 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc0_rule, c)
      }
    }
}
void  State::_sub_Op_PrefetchRead(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6113 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && ReadPrefetchInstr==2
#line 10884 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchrT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6101 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && ReadPrefetchInstr==1
#line 10893 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchrT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6089 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && ReadPrefetchInstr==0
#line 10904 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchrNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && VM_Version::supports_3dnow_prefetch() || ReadPrefetchInstr==3
#line 10915 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchr_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !VM_Version::supports_3dnow_prefetch()
#line 10926 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchr0_rule, c)
      }
    }
}
void  State::_sub_Op_PrefetchWrite(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 10939 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchwNTA_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6135 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && VM_Version::supports_3dnow_prefetch()
#line 10948 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchw_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !VM_Version::supports_3dnow_prefetch()
#line 10959 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchw0_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_XREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_XREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, i2s_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_XREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_XREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[ECXREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI8, _RShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI1, _RShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADUS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADUS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadS2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+600;
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_1_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63, _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63, _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32, _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32, _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule, c)
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10640 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11382 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+125;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, roundDouble_mem_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], _DIVD_REGDPR_REGDPR) &&
        (
#line 9722 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && !(Compile::current()->has_method() && Compile::current()->method()->is_strict()) 
#line 11395 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_DIVD_REGDPR_REGDPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, divDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR_IMMDPR) &&
        (
#line 9550 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && _kids[0]->_kids[1]->_leaf->getd() != 0.0 && _kids[0]->_kids[1]->_leaf->getd() != 1.0 
#line 11418 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR_IMMDPR]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, addDPR_reg_imm_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR__LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR__LOADD_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__, _RoundDouble__AddD_regDPR__LoadD_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD__LOADD_MEMORY__REGDPR) ) {
      unsigned int c = _kids[0]->_cost[_ADDD__LOADD_MEMORY__REGDPR];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_, _RoundDouble__AddD__LoadD_memory__regDPR__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR_REGDPR) &&
        (
#line 9479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11449 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR_REGDPR]+250;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, addDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBD_REGDPR_REGDPR) &&
        (
#line 9417 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE <=1
#line 11472 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBD_REGDPR_REGDPR]+250;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, subDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE_REGDPR1_, _RoundDouble_regDPR1__rule, c)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 11501 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+125;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, roundFloat_mem_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1];
        DFA_PRODUCTION__SET_VALID(_ROUNDFLOAT_REGFPR1_, _RoundFloat_regFPR1__rule, c)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    {
      unsigned int c = 125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_rule, c)
    }
}
void  State::_sub_Op_SinD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 9785 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 11524 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+1800;
        DFA_PRODUCTION__SET_VALID(REGD, sinD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9775 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11533 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+1800;
        DFA_PRODUCTION__SET_VALID(REGDPR1, sinDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, sinDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, sinDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, sinDPR_reg_rule, c)
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD) &&
        (
#line 1729 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=2
#line 11547 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 1717 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=2
#line 11556 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 1705 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=2
#line 11567 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_IMMF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_IMMF_];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D_IMMF__, _SqrtD__ConvF2D_immF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D__LOADF_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D__LOADF_MEMORY__];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D__LOADF_MEMORY___, _SqrtD__ConvF2D__LoadF_memory____rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_REGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_REGF_];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D_REGF__, _SqrtD__ConvF2D_regF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 9859 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11590 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, sqrtDPR_reg_rule, c)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], XREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[XREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 6354 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseStoreImmI16
#line 11616 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI16]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_EREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EAXREGP_EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EAXREGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__) &&
        (
#line 9508 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11657 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addDPR_mem_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_) &&
        (
#line 9508 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11666 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addDPR_mem_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 6425 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 11677 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE_REGDPR1_) &&
        (
#line 6412 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11688 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE_REGDPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeDPR_rounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGDPR1) &&
        (
#line 6400 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11699 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGDPR1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeDPR_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF]+50;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMFPR) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMFPR]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVD2F_REGDPR1_) &&
        (
#line 6474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11722 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVD2F_REGDPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_Drounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDFLOAT_REGFPR1_) &&
        (
#line 6462 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 11733 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDFLOAT_REGFPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_rounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGFPR1) &&
        (
#line 6450 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 11744 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGFPR1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 6438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 11755 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__IMMI]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVL2I_EREGL_) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVL2I_EREGL_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 6311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((StoreLNode*)n)->require_atomic_access()
#line 11905 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[EREGL]+360;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeLX_reg_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], STACKSLOTL) &&
        (
#line 6295 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((StoreLNode*)n)->require_atomic_access()
#line 11914 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[STACKSLOTL]+380;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeLX_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], STACKSLOTL) &&
        (
#line 6282 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && ((StoreLNode*)n)->require_atomic_access()
#line 11925 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[STACKSLOTL]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LONG_MEMORY) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 6255 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
!((StoreLNode*)n)->require_atomic_access()
#line 11936 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[LONG_MEMORY]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], ANYREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[ANYREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ECXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ECXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EDXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compare_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ESIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ESIREGP]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EAXREGI) &&
        (
#line 11545 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE42Intrinsics
#line 11995 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EAXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_IMMI) &&
        (
#line 11518 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE42Intrinsics
#line 12015 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_con_rule, c)
      }
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1274 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 12061 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1262 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 12070 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1250 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 12081 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1239 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 12092 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1227 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 12103 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1215 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 12114 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGDPR_REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 12125 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGDPR_REGDPR]+_kids[1]->_cost[REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_mulDPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9432 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE <=1
#line 12137 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_SUBD_REGDPR_REGDPR, _SubD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9404 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE <=1
#line 12161 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1203 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 12184 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 12193 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1179 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 12204 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1168 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 12215 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1156 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 12226 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1144 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 12237 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_SUBF_REGFPR_REGFPR, _SubF_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10209 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 12252 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, subFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, subFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10196 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 12262 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, subFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_RREGI_RREGI, _SubI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_32) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_32]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_32_ECXREGI, _SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_ECXREGI, _SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0__LOADI_MEMORY_, _SubI_immI0__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, negI_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_RREGI, _SubI_immI0_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__RREGI, _SubI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0__LOADL_MEMORY_, _SubL_immL0__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0_EREGL, _SubL_immL0_eRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(EREGL, negL_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, negL_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, negL_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EBXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EBXREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EAXREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_TanD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 9826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12511 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, tanD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 12520 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, tanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, tanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, tanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, tanDPR_reg_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, tlsLoadP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI_ECXREGI, _URShiftI_ncxRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI1, _URShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI_32_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI, _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI0_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI, _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI8, _URShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI_M1, _URShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+600;
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_1_31_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__IMMI, _XorI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI__LOADI_MEMORY_, _XorI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__RREGI, _XorI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 8089 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 12899 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8089 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 12943 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 8074 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 12987 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8074 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 13031 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI_IMMI_M1, _XorI_rRegI_immI_M1_rule, c)
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 8878 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 13148 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 8878 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 13168 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_EREGL_IMML_M1) &&
        (
#line 8851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 13188 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_ADDL_EREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
UseBMI1Instructions
#line 13208 "../generated/adfiles/dfa_x86_32.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_EREGL_IMML_M1]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL_EREGL_IMML_M1, _XorL_eRegL_immL_M1_rule, c)
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2624 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13234 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2613 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13243 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2602 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 13254 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2591 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 13263 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2581 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 13274 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2570 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13285 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2560 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 13294 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 2549 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13305 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 2539 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13314 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_rule, c)
      }
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2721 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13327 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13336 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2699 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13347 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2688 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13356 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2678 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 13367 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13378 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2657 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13387 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 2646 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13398 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 2636 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13407 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_rule, c)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2797 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13420 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2786 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13429 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2775 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13440 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2764 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13449 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2754 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13460 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2743 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13471 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2733 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13480 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2852 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13493 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2841 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13502 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2830 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13513 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2819 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13522 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13533 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_rule, c)
      }
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13546 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2917 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13555 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2906 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13566 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2895 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13575 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2885 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13586 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2874 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13597 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2864 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13606 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_rule, c)
      }
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2983 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13619 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2972 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13628 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 2961 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13639 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13648 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13659 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_rule, c)
      }
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3082 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13672 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3071 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13681 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3060 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 13692 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3049 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 13701 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3039 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 13712 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3028 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13723 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3018 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 13732 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3007 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13743 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 2997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13752 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_rule, c)
      }
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3179 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13765 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3168 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13774 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3157 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13785 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3146 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13794 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3136 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 13805 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13816 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13825 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3104 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13836 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3094 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13845 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_rule, c)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3255 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13858 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3244 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13867 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3233 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13878 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3222 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13887 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3212 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 13898 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3201 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13909 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13918 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_rule, c)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3310 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13931 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3299 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13940 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3288 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13951 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13960 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3267 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 13971 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_rule, c)
      }
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3386 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13984 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13993 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3364 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14004 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14013 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3343 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14024 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3332 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14035 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14044 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_rule, c)
      }
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3441 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14057 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3430 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14066 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3419 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14077 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3408 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14086 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3398 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14097 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_rule, c)
      }
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3540 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14110 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14119 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3518 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14130 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3507 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14139 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 14150 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3486 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14161 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3476 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14170 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3465 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14181 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3455 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14190 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_rule, c)
      }
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3616 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14203 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14212 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3594 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14223 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3583 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14232 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3573 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 4
#line 14243 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3562 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14254 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3552 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 2
#line 14263 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_rule, c)
      }
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3692 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14276 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14285 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3670 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14296 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3659 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14305 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3649 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14316 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3638 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14327 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3628 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14336 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_rule, c)
      }
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3747 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14349 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3736 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14358 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3725 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14369 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3714 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14378 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3704 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14389 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_rule, c)
      }
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3825 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14402 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3814 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14411 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3803 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14422 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14431 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3782 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14442 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3771 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14453 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3761 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14462 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_rule, c)
      }
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14475 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14484 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 3858 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14495 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14504 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3837 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14515 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_rule, c)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_0_rule, c)
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4045 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14540 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4034 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14549 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4023 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14560 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14569 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4002 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 14580 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3992 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 14591 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 3981 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14602 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3970 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14611 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 3960 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14622 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14633 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 3939 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14644 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14653 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 3918 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14664 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3908 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14675 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4152 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14688 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4141 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14697 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4130 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14708 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4119 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14717 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4109 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14728 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4099 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14739 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4088 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14750 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14759 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14770 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14781 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4217 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 14794 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4206 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 14803 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4195 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14814 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4184 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14823 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4174 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14834 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4164 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14845 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4695 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14858 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4684 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14867 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4673 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14878 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4662 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14887 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4652 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 14898 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4642 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 14909 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14920 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4620 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14929 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4610 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14940 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4600 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 14951 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4589 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14962 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4578 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14971 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4568 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14982 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4558 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 14993 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4802 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15006 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4791 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15015 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4780 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15026 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4769 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15035 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4759 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15046 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4749 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15057 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4738 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15068 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4727 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15077 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4717 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15088 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15099 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4372 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15112 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4361 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15121 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4350 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15132 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4339 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15141 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4329 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15152 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4319 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15163 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4308 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15174 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4297 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15183 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4287 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15194 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15205 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4266 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15216 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4255 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15225 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15236 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15247 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15260 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4468 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15269 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4457 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15280 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4446 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15289 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4436 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15300 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4426 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15311 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4415 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15322 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4404 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15331 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4394 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15342 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15353 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4544 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15366 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4533 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15375 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4522 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15386 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15395 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 4501 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15406 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4491 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15417 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_rule, c)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 4903 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 15430 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4892 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 15439 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 4881 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 15450 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4870 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 15459 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4860 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 16
#line 15470 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4849 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 15481 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4839 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 8
#line 15490 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4828 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 15501 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4818 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 4
#line 15510 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_rule, c)
      }
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5001 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 15523 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4990 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 15532 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 4979 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 15543 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4968 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 15552 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 16
#line 15563 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 15574 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4937 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 8
#line 15583 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4926 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 15594 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 4916 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 4
#line 15603 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_rule, c)
      }
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5099 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 15616 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5088 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 15625 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 15636 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5066 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 15645 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5056 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 16
#line 15656 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5045 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 15667 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5035 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 8
#line 15676 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5024 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 15687 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length_in_bytes() == 4
#line 15696 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_rule, c)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADVECTOR_MEMORY_, _LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 1780 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_LoadVector()->memory_size() == 32
#line 15713 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECY, loadV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 1768 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_LoadVector()->memory_size() == 16
#line 15722 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECX, loadV16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 1756 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_LoadVector()->memory_size() == 8
#line 15731 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECD, loadV8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 1744 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_LoadVector()->memory_size() == 4
#line 15740 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECS, loadV4_rule, c)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 1825 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_StoreVector()->memory_size() == 32
#line 15751 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECY]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 1814 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_StoreVector()->memory_size() == 16
#line 15760 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECX]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 1803 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_StoreVector()->memory_size() == 8
#line 15771 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECD]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 1792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_StoreVector()->memory_size() == 4
#line 15782 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECS]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV4_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 1977 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 32
#line 15795 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 1967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 15804 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 1957 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15813 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 1947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15822 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 1932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 32
#line 15831 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 1920 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 15842 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 1910 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15853 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 1900 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15864 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 1881 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 32
#line 15875 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 1865 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 15886 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 1851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15897 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 1837 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15908 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2122 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 15921 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2112 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15930 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2102 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15939 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2092 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15948 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 15957 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2065 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 15968 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2055 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 15979 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2045 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 15990 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2028 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 16
#line 16001 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16012 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2002 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16023 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 1990 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16034 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2270 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16047 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2260 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16056 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 2250 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16065 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 2235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16074 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 2223 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16085 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 2211 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16096 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2196 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16107 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2184 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16118 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2174 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16129 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2159 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16140 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16151 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2135 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16162 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 2412 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16175 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 2402 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16184 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 2387 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16193 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 2375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16204 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 2360 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16215 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 2348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16226 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 2327 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16237 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 2310 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16248 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16261 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 2468 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16270 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 2458 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16279 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2445 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 8
#line 16288 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2435 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16299 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2425 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16310 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 2523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16323 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 2513 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16332 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 4
#line 16341 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2490 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-13.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
n->as_Vector()->length() == 2
#line 16352 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_rule, c)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_VecS: { _sub_Op_VecS(n);
    break;
  }
  case Op_VecD: { _sub_Op_VecD(n);
    break;
  }
  case Op_VecX: { _sub_Op_VecX(n);
    break;
  }
  case Op_VecY: { _sub_Op_VecY(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_AtanD: { _sub_Op_AtanD(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CosD: { _sub_Op_CosD(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_DivModI: { _sub_Op_DivModI(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_ExpD: { _sub_Op_ExpD(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_Jump: { _sub_Op_Jump(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_LogD: { _sub_Op_LogD(n);
    break;
  }
  case Op_Log10D: { _sub_Op_Log10D(n);
    break;
  }
  case Op_LoopLimit: { _sub_Op_LoopLimit(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModD: { _sub_Op_ModD(n);
    break;
  }
  case Op_ModF: { _sub_Op_ModF(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_OverflowAddI: { _sub_Op_OverflowAddI(n);
    break;
  }
  case Op_OverflowSubI: { _sub_Op_OverflowSubI(n);
    break;
  }
  case Op_OverflowMulI: { _sub_Op_OverflowMulI(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PowD: { _sub_Op_PowD(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_PrefetchRead: { _sub_Op_PrefetchRead(n);
    break;
  }
  case Op_PrefetchWrite: { _sub_Op_PrefetchWrite(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SinD: { _sub_Op_SinD(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_TanD: { _sub_Op_TanD(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
